package it.unibas.indovinam2pinco.controllo;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import it.unibas.indovinam2pinco.modello.*;
import it.unibas.pinco.framework.Applicazione;

public class AzioneGestisciTentativo implements it.unibas.pinco.azioni.Azione {
    
    private boolean richiestaCorretta(HttpServletRequest request) {
        HttpSession session = request.getSession();
        Partita partita = (Partita)session.getAttribute("partita");
        String stringaTentativo = request.getParameter("tentativo");
        if (session.isNew() || partita == null || stringaTentativo == null) {
            return false;
        }
        return true;
    }
    
    public String esegui(HttpServletRequest request){
        if (!richiestaCorretta(request)) {
            return "errore";
        }
        HttpSession session = request.getSession(false);
        Partita partita = (Partita)session.getAttribute("partita");
        String stringaTentativo = request.getParameter("tentativo");
        int tentativo;
        try {
            tentativo = Integer.parseInt(stringaTentativo);
        } catch (NumberFormatException ne) {
            tentativo = -1;
        }
        partita.setTentativo(tentativo);
        if (partita.getTrovato()) {
            ServletContext application = session.getServletContext();
            synchronized (application) {
                Integer numeroGiocatori = (Integer)application.getAttribute("numeroGiocatori");
                application.setAttribute("numeroGiocatori", new Integer(numeroGiocatori.intValue()-1));
            }
            Record record = (Record)application.getAttribute("record");
            record.checkRecord(partita.getNumeroDiTentativi());
            String messaggioRecord = "";
            if (record.isNuovoRecord()) {
                messaggioRecord = "Hai anche stabilito il nuovo record di tentativi";
            } else if (record.isUguagliato()) {
                messaggioRecord = "Hai anche eguagliato il record di tentativi";
            }
            request.setAttribute("messaggioRecord", messaggioRecord);
            Applicazione.logInfo("AzioneGestisciTentativo", "esegui", "Il giocatore " + partita.getNome() + " ha concluso la partita in " + partita.getNumeroDiTentativi() +  " tentativi");
            return "indovinato";
        } else {
            return "continua";
        }
    }
}

