package it.unibas.indovinam2pinco.controllo;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import it.unibas.indovinam2pinco.modello.*;
import it.unibas.pinco.framework.Applicazione;

public class AzioneInterrompiPartita implements it.unibas.pinco.azioni.Azione {
    
    private boolean richiestaCorretta(HttpServletRequest request) {
        HttpSession session = request.getSession();
        Partita partita = (Partita)session.getAttribute("partita");
        if (session.isNew() || partita == null) {
            return false;
        }
        return true;
    }
    
    public String esegui(HttpServletRequest request){
        if (!richiestaCorretta(request)) {
            return "errore";
        }
        HttpSession session = request.getSession(false);
        Partita partita = (Partita)session.getAttribute("partita");
        ServletContext application = session.getServletContext();
        synchronized (application) {
            Integer numeroGiocatori = (Integer)application.getAttribute("numeroGiocatori");
            application.setAttribute("numeroGiocatori", new Integer(numeroGiocatori.intValue() - 1));
        }
        Applicazione.logInfo("AzioneInterrompiPartita", "esegui", "Il giocatore " + partita.getNome() + " ha interrotto la partita");
        return "successo";        
    }
}

