package it.unibas.indovinam2pinco.test.funzionali;

import junit.framework.TestCase;
import com.meterware.httpunit.WebConversation;
import com.meterware.httpunit.WebRequest;
import com.meterware.httpunit.WebResponse;
import com.meterware.httpunit.WebForm;

public class TestPartita extends TestCase {

    private WebConversation conversation;

    public void setUp(){
        conversation = new WebConversation();
    }

    public void testPartita1() throws Exception {
        WebResponse index = richiestaIniziale();
        WebResponse tentativoIniziale = sottomettiFormNome(index);
        WebResponse tentativoSuccessivo = sottomettiFormTentativo(tentativoIniziale);
        WebResponse interruzione = interrompi(tentativoSuccessivo);
        esciDalGioco(interruzione);
    }

    private WebResponse richiestaIniziale() throws Exception {
        WebResponse index = conversation.getResponse("http://localhost:8080/indovinam2pinco/");
        String text = index.getText();
        assertTrue("pagina iniziale", text.indexOf("Vogliamo fare una partita") != -1);
        WebForm[] forms = index.getForms();
        assertTrue("una form", forms.length == 1);
        return index;
    }

    private WebResponse sottomettiFormNome(WebResponse index) throws Exception {
        WebForm formNome = index.getForms()[0];
        formNome.setParameter("nome", "Gianni");
        formNome.submit();
        WebResponse tentativo = conversation.getCurrentPage();
        String text = tentativo.getText();
        assertTrue("pagina tentativo iniziale", text.indexOf("Ho scelto un numero tra 1 e 100") != -1);
        assertTrue("nome", text.indexOf("Gianni") != -1);
        assertTrue("tentativi", text.indexOf("Finora hai effettuato 0 tentativi") != -1);
        WebForm[] forms = tentativo.getForms();
        assertTrue("una form", forms.length == 2);
        return tentativo;
    }

    private WebResponse sottomettiFormTentativo(WebResponse tentativo) throws Exception {
        WebForm formTentativo = tentativo.getForms()[0];
        formTentativo.setParameter("tentativo", "10");
        formTentativo.submit();
        WebResponse tentativoSuccessivo = conversation.getCurrentPage();
        String text = tentativoSuccessivo.getText();
        if (text.indexOf("Bravo") != -1) {
            assertTrue("pagina primo tentativo", text.indexOf("Prova con un numero") != -1);
            assertTrue("nome", text.indexOf("Gianni") != -1);
            assertTrue("tentativi", text.indexOf("Finora hai effettuato 1 tentativi") != -1);
            WebForm[] forms = tentativoSuccessivo.getForms();
            assertTrue("due form", forms.length == 2);
        }
        return tentativoSuccessivo;
    }

    private WebResponse interrompi(WebResponse tentativo) throws Exception {
        WebForm formTentativo = tentativo.getForms()[1];
        formTentativo.submit();
        WebResponse interruzione = conversation.getCurrentPage();
        String text = interruzione.getText();
        assertTrue("pagina interruzione", text.indexOf("Partita Interrotta") != -1);
        assertTrue("numero", text.indexOf("Il numero da indovinare era") != -1);
        assertTrue("tentativi", text.indexOf("Hai effettuato in totale") != -1);
        assertTrue("tentativi 2", text.indexOf("<strong>1</strong> tentativi") != -1);
        WebForm[] forms = interruzione.getForms();
        assertTrue("due form", forms.length == 2);
        return interruzione;
    }

    private void esciDalGioco(WebResponse interruzione) throws Exception {
        WebForm formEsci = interruzione.getForms()[1];
        formEsci.submit();
        WebResponse esci = conversation.getCurrentPage();
        String text = esci.getText();
        assertTrue("pagina uscita", text.indexOf("Ok, arrivederci") != -1);
    }
}


