package it.unibas.indovinam2pinco.test.modello;

import junit.framework.TestCase;
import it.unibas.indovinam2pinco.modello.Partita;

public class TestPartita extends TestCase {

    private Partita partita;

    protected void setUp() {
        partita = new Partita();
        assertTrue(partita != null);
    }

    public void testPartita1() {
        assertTrue("numero", (partita.getNumeroDaIndovinare() >= 1 && partita.getNumeroDaIndovinare() <= 100));
        assertTrue("trovato", partita.getTrovato() == false);
        assertTrue("tentativi", partita.getNumeroDiTentativi() == 0);
    }

    public void testSetTentativoBasso() {
        int tentativi = partita.getNumeroDiTentativi();
        int numeroDaIndovinare = partita.getNumeroDaIndovinare();
        partita.setTentativo(numeroDaIndovinare - 1);
        String suggerimento = partita.getSuggerimento();
        assertTrue("suggerimento", suggerimento.equals("Prova con un numero piu' alto"));
        assertTrue("trovato", partita.getTrovato() == false);
        assertTrue("tentativi", partita.getNumeroDiTentativi() == tentativi + 1);
    }

    public void testSetTentativoAlto() {
        int tentativi = partita.getNumeroDiTentativi();
        int numeroDaIndovinare = partita.getNumeroDaIndovinare();
        partita.setTentativo(numeroDaIndovinare + 1);
        String suggerimento = partita.getSuggerimento();
        assertTrue("suggerimento", suggerimento.equals("Prova con un numero piu' basso"));
        assertTrue("trovato", partita.getTrovato() == false);
        assertTrue("tentativi", partita.getNumeroDiTentativi() == tentativi + 1);
    }

    public void testSetTentativoEsatto() {
        int tentativi = partita.getNumeroDiTentativi();
        int numeroDaIndovinare = partita.getNumeroDaIndovinare();
        partita.setTentativo(numeroDaIndovinare);
        String suggerimento = partita.getSuggerimento();
        assertTrue("suggerimento", suggerimento.equals("Numero indovinato"));
        assertTrue("trovato", partita.getTrovato() == true);
        assertTrue("tentativi", partita.getNumeroDiTentativi() == tentativi + 1);
    }

    public void testSetTentativoTroppoBasso() {
        int tentativi = partita.getNumeroDiTentativi();
        partita.setTentativo(-1);
        String suggerimento = partita.getSuggerimento();
        assertTrue("suggerimento", suggerimento.equals("Prova con un numero tra 1 e 100"));
        assertTrue("trovato", partita.getTrovato() == false);
        assertTrue("tentativi", partita.getNumeroDiTentativi() == tentativi);
    }

    public void testSetTentativoTroppoAlto() {
        int tentativi = partita.getNumeroDiTentativi();
        partita.setTentativo(-1);
        String suggerimento = partita.getSuggerimento();
        assertTrue("suggerimento", suggerimento.equals("Prova con un numero tra 1 e 100"));
        assertTrue("trovato", partita.getTrovato() == false);
        assertTrue("partita", partita.getNumeroDiTentativi() == tentativi);
    }
}
