package it.unibas.indovinam2pinco.test.modello;

import junit.framework.TestCase;
import it.unibas.indovinam2pinco.modello.Record;

public class TestRecord extends TestCase {

    private Record record;

    protected void setUp() {
        record = Record.getInstance();
    }

    public void testGetInstance () {
        assertNotNull("non nullo", record);
        Record record1 = Record.getInstance();
        assertEquals("singleton", record, record1);
    }

    public void testSetEGetRecord() {
        int valoreIniziale = record.getValoreRecord();
        assertTrue("valore iniziale",  (valoreIniziale >= 1 && valoreIniziale <= 101));
        record.setValoreRecord(10);
        assertTrue(record.getValoreRecord()+"", record.getValoreRecord() == 10);
    }

    public void testSetEGetRecordErrori() {
        record.setValoreRecord(10);
        record.setValoreRecord(-1);
        record.setValoreRecord(200);
        assertTrue(record.getValoreRecord()+"", record.getValoreRecord() == 10);
    }

    public void testCheckRecord() {
        record.setValoreRecord(10);
        record.checkRecord(20);
        assertTrue("nuovo record", record.isNuovoRecord() == false);
        assertTrue("uguagliato", record.isUguagliato() == false);
    }

    public void testCheckRecordNuovoRecord() {
        record.setValoreRecord(10);
        record.checkRecord(3);
        assertTrue("nuovo record", record.isNuovoRecord() == true);
        assertTrue("uguagliato", record.isUguagliato() == false);
        assertTrue("valore record"+record.getValoreRecord(), record.getValoreRecord() == 3);
    }

    public void testCheckRecordUguagliato() {
        record.setValoreRecord(10);
        record.checkRecord(10);
        assertTrue("nuovo record", record.isNuovoRecord() == false);
        assertTrue("uguagliato", record.isUguagliato() == true);
        assertTrue("valore record"+record.getValoreRecord(), record.getValoreRecord() == 10);
    }
}

